<template>
  <div data-app>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nickname</label>

            <b-form-select
              v-model="filter.nickname"
              :options="formattedProjectOptions"
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Owner</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.ownerName"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nama Proyek</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.projectName"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nomor Kontrak</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.contractNumber"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Status</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.status"
              disabled
            ></b-form-input>
          </div>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Stasiun</label>

            <b-form-select
              v-model="filter.station"
              :options="formattedStationOptions"
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Scope</label>

            <b-form-select
              v-model="filter.scope"
              :options="formattedScopeOptions"
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Title</label>

            <b-form-input id="input-large" size="lg"></b-form-input>
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md">
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <b-tabs content-class="mt-3">
          <b-tab title="Document" @click="loadDesigns('DOC')" active>
            <tab-content
              :project="selectedNickname"
              :items="dlDesigns"
              :loading="loadingProjects"
              design-type="DOC"
              @loadDesigns="loadDesigns"
            />
          </b-tab>

          <b-tab title="Drawing" @click="loadDesigns('DRW')">
            <tab-content
              :project="selectedNickname"
              :items="dlDesigns"
              :loading="loadingProjects"
              design-type="DRW"
              @loadDesigns="loadDesigns"
            />
          </b-tab>

          <b-tab title="Software" @click="loadDesigns('FOR')">
            <tab-content
              :project="selectedNickname"
              :items="dlDesigns"
              :loading="loadingProjects"
              design-type="FOR"
              @loadDesigns="loadDesigns"
            />
          </b-tab>
        </b-tabs>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState } from "vuex";
import { GET_SCOPES } from "@/core/services/store/scope.module.js";
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module.js";
import { GET_OUTSTANDING } from "@/core/services/store/outstanding.module.js";
import { GET_DETAIL_DL_DESIGN_LIST } from "@/core/services/store/dl.design.module.js";
import { GET_PROJECT_DETAIL } from "@/core/services/store/project.module.js";
import { GET_STATION } from "../../../core/services/store/station.module";
import TabContent from "./detail/TabContent";

export default {
  name: "DetailDlDesign",
  components: {
    TabContent
  },
  data() {
    return {
      filter: {
        id_project: null,
        nickname: null,
        station: null,
        scope: null,
        jobdesk: "design"
      },
      selectedNickname: {
        ownerName: null,
        projectName: null,
        status: null,
        contractNumber: null,
        code: null
      },
      options: {
        nicknames: [
          { value: null, text: "Pilih Nickname" },
          { value: "1", text: "Makpa 1" },
          { value: "2", text: "Makpa 2" }
        ],
        stations: [
          { value: null, text: "Pilih Stasiun" },
          { value: "1", text: "LRS0123123" },
          { value: "2", text: "LRS0000001" }
        ],
        scopes: [
          { value: null, text: "Pilih Scope" },
          { value: "1", text: "HMI" },
          { value: "2", text: "CHIEF" }
        ]
      }
    };
  },

  computed: {
    ...mapState({
      errors: state => state.position.errors,
      dlDesigns: state => state.design.detailDlDesignList?.data?.dld,
      scopes: state => state.scope.scopes?.data,
      outstandings: state => state.outstanding.outstanding?.data,
      projects: state => state.projectDetails.projectDetails?.data,
      stations: state => state.stations.stations?.data,
      loadingProjects: state => state.design.loading
    }),

    currentIdProject() {
      return this.filter.id_project;
    },

    currentNickname() {
      return this.filter.nickname;
    },

    currentDlDesigns() {
      return this.dlDesigns;
    },

    formattedScopeOptions() {
      let scopes = [];

      if (this.arrayMoreThanOne(this.scopes)) {
        scopes = this.scopes.map(scope => {
          return {
            value: scope.code,
            text: scope.name
          };
        });
      }

      return [{ value: null, text: "Pilih Scope" }, ...scopes];
    },

    formattedProjectOptions() {
      let projects = [];

      if (this.arrayMoreThanOne(this.projects)) {
        projects = this.projects.map(project => {
          return {
            value: project.code,
            text: project.nickname
          };
        });
      }

      return [{ value: null, text: "Pilih Nickname" }, ...projects];
    },

    formattedStationOptions() {
      let stations = [];

      if (this.arrayMoreThanOne(this.stations)) {
        stations = this.stations.map(project => {
          return {
            value: project.code,
            text: project.name
          };
        });
      }

      return [{ value: null, text: "Pilih Stasiun" }, ...stations];
    }
  },

  watch: {
    currentNickname(value) {
      if (!value) {
        Object.assign(this.selectedNickname, {
          ownerName: null,
          projectName: null,
          status: null,
          contractNumber: null,
          code: null
        });

        return;
      }

      const project = this.projects.find(
        project => project.code === this.filter.nickname
      );

      Object.assign(this.selectedNickname, {
        ownerName: project?.owner,
        projectName: project?.name,
        status: project?.status,
        contractNumber: project?.contract_no,
        ...project
      });
    },

    currentIdProject(value) {
      if (value) {
        this.getDlDesigns();
      }
    }
  },

  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Detail Dl Design" }]);

    this.getScopes();

    this.getOutstandings();

    this.getProjects();

    this.getStations();
  },

  methods: {
    loadDesigns(type) {
      if (!this.filter.nickname) {
        this.$bvToast.toast("Pilih nickname terlebih dahulu.", {
          title: "Warning",
          variant: "warning",
          solid: true
        });
      } else {
        this.getDlDesigns(type);
      }
    },

    getProjects() {
      if (!this.arrayMoreThanOne(this.projects)) {
        this.$store.dispatch(GET_PROJECT_DETAIL, { jobdesk: "design" });
      }
    },

    getDlDesigns(type) {
      this.$store.dispatch(GET_DETAIL_DL_DESIGN_LIST, {
        project_id: this.selectedNickname?.code,
        type_design: type
      });
    },

    getScopes() {
      if (!this.arrayMoreThanOne(this.scopes)) {
        this.$store.dispatch(GET_SCOPES, this.filter);
      }
    },

    getStations() {
      if (!this.arrayMoreThanOne(this.stations)) {
        this.$store.dispatch(GET_STATION, {});
      }
    },

    getOutstandings() {
      if (!this.arrayMoreThanOne(this.outstandings)) {
        this.$store.dispatch(GET_OUTSTANDING, this.filter);
      }
    },

    arrayMoreThanOne(array) {
      return array?.length > 0;
    }
  }
};
</script>

<style></style>
